import { milestoneClosedLabels, missedMilestoneLabels } from '../config/index.js';

export const createReport = ({ data = {} } = {}) => {

    const report = [];

    if(!data && Object.keys(data).length !== 0){
        throw new Error("No data to report on");
    }

    if(data?.closed?.total?.issues.length > 0){
        const closed = data?.closed;
        report.push(`## Report for Milestone: ${data?.milestone}`);
        report.push(`\n`);
        report.push(`###### Closed Issues`);
        report.push(`\n`);
        report.push(`| Issues Type | Count | Weight | `);
        report.push(`| ------ | ------ | ------ | `);
        report.push(`| Total | ${closed?.total?.count} | ${closed?.total?.weight} | `);
        milestoneClosedLabels.forEach(milestoneLabel => {
            if(closed[milestoneLabel.var]?.count !== 0){
                const countPercent = closed[milestoneLabel.var]?.count / closed?.total?.count * 100;
                const weightPercent = closed[milestoneLabel.var]?.weight / closed?.total?.weight * 100;
                report.push(`| ~"${milestoneLabel.label}" | ${closed[milestoneLabel.var]?.count} (${countPercent.toFixed()}%) | ${closed[milestoneLabel.var]?.weight} (${weightPercent.toFixed()}%) | `);
            }
        });
        report.push(`\n`);
        data?.closed?.total?.issues.forEach(issue => {
            report.push(`1. ${issue}+`);
        });    
    }

    if(data?.missed?.total?.issues.length > 0){
        const missed = data?.missed;
        report.push(`###### Missed Issues`);
        report.push(`\n`);
        report.push(`| Issues Type | Count | Weight | `);
        report.push(`| ------ | ------ | ------ | `);
        report.push(`| Total | ${missed?.total?.count} | ${missed?.total?.weight} | `);
        missedMilestoneLabels.forEach(milestoneLabel => {
            if(missed[milestoneLabel.var]?.count !== 0){
                const countPercent = missed[milestoneLabel.var]?.count / missed?.total?.count * 100;
                const weightPercent = missed[milestoneLabel.var]?.weight / missed?.total?.weight * 100;
                report.push(`| ~"${milestoneLabel.label}" | ${missed[milestoneLabel.var]?.count} (${countPercent.toFixed()}%) | ${missed[milestoneLabel.var]?.weight} (${weightPercent.toFixed()}%) | `);
            }
        });
        report.push(`\n`);
        data?.missed?.total?.issues.forEach(issue => {
            report.push(`1. ${issue}+`);
        });
    }

    report.push("\n-------------------------");
    report.push("\nThis report was [autogenerated](https://gitlab.com/gitlab-org/govern/compliance/cross-functional-prioritisation-report).")

    return report.join("\n");
};
